package com.smartgwt.sample.server;

import java.sql.Connection;
import java.sql.DriverManager;

import org.olap4j.OlapConnection;
import org.olap4j.OlapWrapper;

public class DBConnection {

	/**
	 * create a connection to Jasper Server
	 * @return
	 * @throws Exception
	 */
	public static OlapConnection getConnectionJasper() throws Exception {
		Class.forName("org.olap4j.driver.xmla.XmlaOlap4jDriver");
		Connection connectionXMLA =
		DriverManager.getConnection(
		"jdbc:xmla:" +
		"Server=http://localhost:8080/jasperserver/xmla",
		"admin","admin");
		OlapWrapper wrapper = (OlapWrapper) connectionXMLA;
		OlapConnection olapConnection = wrapper.unwrap(OlapConnection.class);
		return olapConnection;
    }
	
	/**
	 * create a connection to Mondrian Server
	 * @return
	 * @throws Exception
	 */
	public static OlapConnection getConnection() throws Exception {
		Class.forName("org.olap4j.driver.xmla.XmlaOlap4jDriver");
		Connection connectionXMLA =
		DriverManager.getConnection(
		"jdbc:xmla:" +
		"Server=http://localhost:8080/mondrian/xmla",
		"foodmart","foodmart");
		OlapWrapper wrapper = (OlapWrapper) connectionXMLA;
		OlapConnection olapConnection = wrapper.unwrap(OlapConnection.class);
		return olapConnection;
    }
	
	/**
	 * create a connection to Analysis Services Server
	 * @return
	 * @throws Exception
	 */
	public static OlapConnection getConnectionAServices() throws Exception {
		Class.forName("org.olap4j.driver.xmla.XmlaOlap4jDriver");
		// anonymous connection
		Connection connectionXMLA =	DriverManager.getConnection(
			"jdbc:xmla:Server=http://localhost/olap/msmdpump.dll;"+
			"Catalog=Adventure Works DW 2008R2 SE;");
		
		OlapWrapper wrapper = (OlapWrapper) connectionXMLA;
		OlapConnection olapConnection = wrapper.unwrap(OlapConnection.class);
		return olapConnection;
    }
}
