package com.smartgwt.sample.server;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.olap4j.Axis;
import org.olap4j.Cell;
import org.olap4j.CellSet;
import org.olap4j.OlapConnection;
import org.olap4j.OlapStatement;
import org.olap4j.Position;
import org.olap4j.metadata.Member;
import com.isomorphic.datasource.BasicDataSource;
import com.isomorphic.datasource.DSRequest;
import com.isomorphic.datasource.DSResponse;

public class OLAPDataSource extends BasicDataSource {  
	  

    public DSResponse executeFetch(DSRequest req) throws Exception {  
        DSResponse resp = new DSResponse();
        resp.setData(fetchRecordsAll(req, resp));
        resp.setStatus(0);
        return resp;  
    }  
  
    private List fetchRecordsAll (DSRequest req, DSResponse resp) throws Exception {
    	List collection = new ArrayList();
    	Map criteria = req.getCriteria();
        if ((criteria.get("rowFacets") == null) || (criteria.get("columnFacets") == null)) return collection;
    	String scenario = criteria.get("Scenarios").toString();
    	String rowFacets = criteria.get("rowFacets").toString();
    	String columnFacets = criteria.get("columnFacets").toString();
    	String[] rows = rowFacets.split(",");
    	String[] columns = columnFacets.split(",");
    	StringBuffer query = new StringBuffer();
    	
    	////COLUMNS//////
    	if (columns.length > 1) {
    		if (columns.length > 2) {
    			query.append("SELECT CrossJoin( ");
    		} else {
    			query.append("SELECT (");
    		}
    	} else {
    		query.append("SELECT (");
    	}
    	for (int i = 0; i < columns.length; i++) {
    		int x = i;
    		x++;
    		Object obj = criteria.get(columns[i].replaceAll(" ", ""));
    		ArrayList values = new ArrayList();
    		if (obj instanceof ArrayList) {
    			values = (ArrayList)obj;
    		} else { 
    			values.add((String)obj);
    		}
    		if (((x) == 1) && (columns.length > 1)) {
    			query.append("CrossJoin( ");
    		} else if ((x > 1) && ((x % 2) != 0)) {
    			if (x != columns.length) {
    				query.append(",CrossJoin( ");
    			} else {
    				query.append(", ");
    			}
    		} else if (x != 1) {
    			query.append(", ");
    		}
        	if (values.size() > 1) {
        		query.append("{");
    	    	for (int j = 0; j < values.size(); j++) {
    	    		if (j > 0) query.append(", ");
    	    		String value = (values.get(j)).toString().replace("[[","[").replace("]]","]");
    	    		query.append("["+columns[i]+"]."+value);
    	    	}
    	    	query.append("} ");
        	} else {
        		String value = (values.get(0)).toString().replace("[[","[").replace("]]","]");
        		query.append("{["+columns[i]+"]."+value+"}");
        	}
        	if ((x % 2) == 0) {
    			query.append(")");
    		}
    	}
    	query.append(") ON COLUMNS, ");
    	////ROWS/////
    	if (rows.length > 1) {
    		if (rows.length > 2) {
    			query.append(" CrossJoin( ");
    		} else {
    			query.append("( ");
    		}
    	} else {
    		query.append("( ");
    	}
    	for (int i = 0; i < rows.length; i++) {
    		int x = i;
    		x++;
    		Object obj = criteria.get(rows[i].replaceAll(" ", ""));
    		ArrayList values = new ArrayList();
    		if (obj instanceof ArrayList) {
    			values = (ArrayList)obj;
    		} else { 
    			values.add((String)obj);
    		}
    		if ((x == 1) && (rows.length > 1)) {
    			query.append("CrossJoin( ");
    		} else if ((x > 1) && ((x % 2) != 0)) {
    			if (x != rows.length) {
    				query.append(",CrossJoin( ");
    			} else {
    				query.append(", ");
    			}
    		} else if (x != 1) {
    			query.append(", ");
    		}
        	if (values.size() > 1) {
        		query.append("{");
    	    	for (int j = 0; j < values.size(); j++) {
    	    		if (j > 0) query.append(", ");
    	    		String value = (values.get(j)).toString().replace("[[","[").replace("]]","]");
    	    		query.append("["+rows[i]+"]."+value);
    	    	}
    	    	query.append("} ");
        	} else {
        		String value = (values.get(0)).toString().replace("[[","[").replace("]]","]");
        		query.append("{["+rows[i]+"]."+value+"}");
        	}
        	if ((x % 2) == 0) {
    			query.append(")");
    		}
    	}
    	query.append(") ON ROWS ");
    	query.append("FROM ["+scenario+"] ");
    	
    	OlapConnection olapConnection = DBConnection.getConnection();
		OlapStatement statement = olapConnection.createStatement();
		CellSet cellSet = statement.executeOlapQuery(query.toString());
		int count = 0;
		Map data = null;
		for (Position axis_0 : cellSet.getAxes().get(Axis.COLUMNS.axisOrdinal()).getPositions()) {
			List<Member> mem0 = axis_0.getMembers();
			for (Position axis_1 : cellSet.getAxes().get(Axis.ROWS.axisOrdinal()).getPositions()) {
				List<Member> mem1 = axis_1.getMembers();
				Cell currentCell = cellSet.getCell(axis_0, axis_1);
				data = new HashMap();
				for (int i = 0; i < mem0.size(); i++) {
					data.put(mem0.get(i).getDimension().getName().replaceAll(" ", ""), mem0.get(i).getUniqueName());
				}
				for (int i = 0; i < mem1.size(); i++) {
					data.put(mem1.get(i).getDimension().getName().replaceAll(" ", ""), mem1.get(i).getUniqueName());
				}
				data.put("value", Float.parseFloat((currentCell.getValue()==null)?"0":currentCell.getValue().toString()));
				data.put("cellID", count);
				data.put("Scenarios", scenario);
		    	collection.add(data);
		    	count+=1;
			}
		}
		statement.close();
		olapConnection.close();
		return collection;
    }  
    

}
