package com.smartgwt.sample.server;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.olap4j.OlapConnection;
import org.olap4j.metadata.Cube;
import org.olap4j.metadata.NamedList;

import com.isomorphic.datasource.BasicDataSource;
import com.isomorphic.datasource.DSRequest;
import com.isomorphic.datasource.DSResponse;

public class OLAPDataSourceCubes extends BasicDataSource {  
	  

    public DSResponse executeFetch(DSRequest req) throws Exception {  
        DSResponse resp = new DSResponse();
        resp.setData(fetchRecordsCubes(req, resp));
        resp.setStatus(0);
        return resp;  
    }  
  
    private List fetchRecordsCubes (DSRequest req, DSResponse resp) throws Exception {  
    	List collection = new ArrayList();
    	OlapConnection olapConnection = DBConnection.getConnection();
    	NamedList<Cube> cubes = olapConnection.getOlapSchema().getCubes();
		Map data = null;
		for (int i = 0; i < cubes.size(); i++) {
			data = new HashMap();
			data.put("idCube", cubes.get(i).getName().replaceAll(" ", ""));
			data.put("nameCube", cubes.get(i).getName());
			collection.add(data);
		}
		olapConnection.close();
		return collection;
    }  
    
    
    
    

}
