package com.smartgwt.sample.server;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.olap4j.Axis;
import org.olap4j.CellSet;
import org.olap4j.OlapConnection;
import org.olap4j.OlapStatement;
import org.olap4j.Position;
import org.olap4j.metadata.Member;

import com.isomorphic.datasource.BasicDataSource;
import com.isomorphic.datasource.DSRequest;
import com.isomorphic.datasource.DSResponse;

public class OLAPDataSourceMembers extends BasicDataSource {  
	  

    public DSResponse executeFetch(DSRequest req) throws Exception {  
        DSResponse resp = new DSResponse();
        resp.setData(fetchRecordsMembers(req, resp));
        resp.setStatus(0);
        return resp;  
    }  
  
    private List fetchRecordsMembers (DSRequest req, DSResponse resp) throws Exception {  
    	List collection = new ArrayList();
    	Map criteria = req.getCriteria();
    	String nameCube = criteria.get("nameCube").toString();
    	String nameDimensions = criteria.get("rowFacets").toString()+criteria.get("columnFacets").toString();
    	String[] dimensions = nameDimensions.split(",");
    	OlapConnection olapConnection = DBConnection.getConnection();
    	OlapStatement statement = olapConnection.createStatement();
    	for (int i = 0; i < dimensions.length; i++) {
    		String query = "SELECT {["+dimensions[i]+"].["+dimensions[i]+"].Members} ON COLUMNS FROM ["+nameCube+"]";
			CellSet cellSet = statement.executeOlapQuery(query);
			int count = 0;
			int m = 0;
			Map data = null;
			boolean existRoot = false;
			boolean rootCollapsed = false;
			for (Position axis_0 : cellSet.getAxes().get(Axis.COLUMNS.axisOrdinal()).getPositions()) {
				List<Member> mem0 = axis_0.getMembers();
				data = new HashMap();
		    	count+=1;
				data.put("idMember", mem0.get(0).getUniqueName());
				data.put("nameMember", mem0.get(0).getName());
				data.put("idParent", (mem0.get(0).getParentMember() == null)?"":mem0.get(0).getParentMember().getUniqueName());
				data.put("idDimension", dimensions[i].replaceAll(" ", ""));
				data.put("collapsed", false);
				if (mem0.get(0).getDepth() == 0) {// verify the root facetValue
					if (mem0.get(0).getChildMemberCount() > 20) {// put the limit of 20 children
						data.put("collapsed", true);
						rootCollapsed = true;
					}
					existRoot = true;
				} else if (mem0.get(0).getDepth() == 1) {
					if ((existRoot) && (!rootCollapsed)) {
						data.put("collapsed", true);
					}
				}
				collection.add(data);
				m++;
			}
    	}
		olapConnection.close();
		return collection;
    }  
    
}